/*
ID: espr1t
LANG: C++
TASK: Zero
COMP: NOI 2011, Round 3
KEYWORDS: Medium, Dynamic Programming
*/

#include <cstdio>
#include <cstring>
#include <algorithm>

#define MAX 5
#define BASE 28
#define MASK 17210368
#define MOD 1000000007

FILE *in; FILE *out;

int a[MAX][BASE];
int dyn[MASK], pows[MAX], len[MAX], idx[MAX];

int recurse()
{
	int flag = 1, mask = 0;
	for (int i = 0; i < MAX; i++)
	{
		if (idx[i] < len[i])
			flag = 0;
		mask = mask * BASE + idx[i];
	}
	if (flag) return 1;
	if (dyn[mask] != -1) return dyn[mask];
	
	int ans = 0;
	for (int i1 = 0; i1 < MAX; i1++)
	{
		int i2 = (i1 + 1) % MAX;
		// If both girls are not at zero
		if (idx[i1] < len[i1] && idx[i2] < len[i2])
		{
			// If both girls have odd numbers
			if (a[i1][idx[i1]] == 1 && a[i2][idx[i2]] == 1)
			{
				// Try to subtract
				idx[i1]++; idx[i2]++;
				ans += recurse();
				if (ans >= MOD) ans -= MOD;
				idx[i1]--; idx[i2]--;
			}
			// Try to divide
			int s1 = idx[i1], s2 = idx[i2];
			idx[i1] = std::min(idx[i1] + a[i1][idx[i1]] + 1, len[i1]);
			idx[i2] = std::min(idx[i2] + a[i2][idx[i2]] + 1, len[i2]);
			ans += recurse();
			if (ans >= MOD) ans -= MOD;
			idx[i1] = s1; idx[i2] = s2;
		}
	}
	return dyn[mask] = ans;
}

int main(void)
{
	in = stdin; out = stdout;
//	in = fopen("zero.in", "rt"); out = fopen("zero.out", "wt");
	
	pows[0] = 1;
	for (int i = 1; i < MAX; i++)
		pows[i] = pows[i - 1] * BASE;
	
	for (int i = 0; i < MAX; i++)
		len[i] = 0;

	for (int i = 0; i < MAX; i++)
	{
		int num;
		fscanf(in, "%d", &num);

		while (num)
		{
			if (num & 1)
			{
				a[i][len[i]++] = 1;
				num--;
			}
			else
			{
				a[i][len[i]++] = 0;
				num >>= 1;
			}
		}
	}
	memset(idx, 0, sizeof(idx));
	memset(dyn, -1, sizeof(dyn));
	fprintf(out, "%d\n", recurse());
	return 0;
}
