/*
ID: espr1t
LANG: C++
TASK: Zero
COMP: NOI 2011, Round 3
*/

#include <cstdio>
#include <cstring>
#include <map>
#include <vector>
#include <iostream>

#define MAX 5
#define MOD 1000000007

using namespace std;
FILE *in; FILE *out;

struct State
{
	int a[MAX];
	bool operator < (const State& r) const
	{
		for (int i = 0; i < MAX; i++)
			if (a[i] != r.a[i]) return a[i] < r.a[i];
		return false;
	}
};

State cur;
map <State, int> dyn;

int recurse()
{
	int flag = 1;
	for (int i = 0; i < MAX; i++)
		if (cur.a[i] != 0) flag = 0;
	if (flag) return 1;
	if (dyn.find(cur) != dyn.end())
		return dyn[cur];
	
	int ans = 0;
	for (int i1 = 0; i1 < MAX; i1++)
	{
		int i2 = (i1 + 1) % MAX;
		// If both girls are not at zero
		if (cur.a[i1] > 0 && cur.a[i2] > 0)
		{
			// If both girls have odd numbers
			if (cur.a[i1] % 2 == 1 && cur.a[i2] % 2 == 1)
			{
				// Try to subtract
				cur.a[i1]--; cur.a[i2]--;
				ans += recurse();
				if (ans >= MOD)
					ans -= MOD;
				cur.a[i1]++; cur.a[i2]++;
			}
			// Try to divide
			int s1 = cur.a[i1]; cur.a[i1] /= 2;
			int s2 = cur.a[i2]; cur.a[i2] /= 2;
			ans += recurse();
			if (ans >= MOD)
				ans -= MOD;
			cur.a[i1] = s1; cur.a[i2] = s2;
		}
	}
	return dyn[cur] = ans;
}

int main(void)
{
	in = stdin; out = stdout;
//	in = fopen("zero.in", "rt"); out = fopen("zero.out", "wt");
	
	for (int i = 0; i < MAX; i++)
		fscanf(in, "%d", &cur.a[i]);
	
	dyn.clear();
	fprintf(out, "%d\n", recurse());
	return 0;
}
