/*
ID: espr1t
LANG: C++
TASK: Zero
COMP: Winter Mathematical Celebrations 2011
*/

#include <cstdio>
#include <cstring>
#include <map>
#include <vector>
#include <iostream>

#define MAX 5
#define MOD 1000000007

using namespace std;
FILE *in; FILE *out;

struct State
{
	int a[MAX];
	bool operator < (const State& r) const
	{
		for (int i = 0; i < MAX; i++)
			if (a[i] != r.a[i]) return a[i] < r.a[i];
		return false;
	}
};

State cur;
map <State, int> dyn;

int recurse()
{
	int flag = 1;
	for (int i = 0; i < MAX; i++)
		if (cur.a[i] != 0) flag = 0;
	if (flag) return 1;
	if (dyn.find(cur) != dyn.end())
		return dyn[cur];
	
	int ans = 0;
	for (int i1 = 0; i1 < MAX; i1++)
	{
		int i2 = (i1 + 1) % MAX;
		// If both girls are not at zero
		if (cur.a[i1] > 0 && cur.a[i2] > 0)
		{
			// If both girls have odd numbers
			if (cur.a[i1] % 2 == 1 && cur.a[i2] % 2 == 1)
			{
				// Try to subtract
				cur.a[i1]--; cur.a[i2]--;
				ans += recurse();
				if (ans >= MOD)
					ans -= MOD;
				cur.a[i1]++; cur.a[i2]++;
			}
			// Try to divide
			int s1 = cur.a[i1]; cur.a[i1] /= 2;
			int s2 = cur.a[i2]; cur.a[i2] /= 2;
			ans += recurse();
			if (ans >= MOD)
				ans -= MOD;
			cur.a[i1] = s1; cur.a[i2] = s2;
		}
	}
	return dyn[cur] = ans;
}

int solve(char* inpFile, char* outFile)
{
	in = fopen(inpFile, "rt"); out = fopen(outFile, "wt");
	
	for (int i = 0; i < MAX; i++)
		fscanf(in, "%d", &cur.a[i]);
	
	dyn.clear();
	fprintf(out, "%d\n", recurse());
	
	fclose(in); fclose(out);
	return 0;
}

int main(void)
{
	int numTests = 20;
	for (int test = 0; test <= numTests; test++)
	{
		fprintf(stderr, "Solving test number %d...", test);
		unsigned sTime = clock();
		char inpFile[32], outFile[32];
		sprintf(inpFile, "zero.%02d.in", test);
		sprintf(outFile, "zero.%02d.ans", test);
		solve(inpFile, outFile);
		fprintf(stderr, " Execution time was %.3lf seconds!\n", (double)(clock() - sTime) / (double)CLOCKS_PER_SEC);
	}
	fprintf(stderr, "Finished solving all testcases!\n");
	system("pause");
	return 0;
}


