#include <cstdio>
#include <algorithm>

struct point
{
    int x, y;
    bool operator<(const point &b) const
    {
        return y < b.y;
    }
};

const int MAXN = 2000 + 10;

int W, H, S, N;
point p[MAXN];

void read()
{
    scanf("%d%d%d", &W, &H, &S);
    scanf("%d", &N);
    for (int i = 0; i < N; i++)
    {
        scanf("%d%d", &p[i].x, &p[i].y);
    }
    std::sort(p, p + N);
}

bool solve()
{
    p[N] = (point){0, 0}; // be careful to include the left edge of the field as a potential left border of the tent
    for (int i = 0; i <= N; i++)
    {
        int x = p[i].x;
        if (x + S > W)
        {
            continue;
        }
        int lastY = 0;
        for (int j = 0; j < N; j++)
        {
            if (p[j].x > x && p[j].x < x + S)
            {
                if (p[j].y - lastY >= S)
                {
                    return true;
                }
                lastY = p[j].y;
            }
        }
        if (H - lastY >= S) // corner case: tent is between excrement and top of the field
        {
            return true;
        }
    }
}

int main()
{
    read();
    bool can = solve();
    if (can)
    {
        printf("YES\n");
    }
    else
    {
        printf("NO\n");
    }
    
    return 0;
}
