/*
TASK: balanced
LANG: C++
AUTH: K. Georgiev, 5/2011.
*/
#include <iostream>
#include <algorithm>
#include <cstring>
#include <cstdlib>
using namespace std;

typedef long long unsigned ull;

int const max_b = 10;
int const max_d = 18;
int const max_s = 59049; // 3^10

int pow3[max_b];
void init_pow3(){
	pow3[0] = 1;
	for(int i = 1; i < max_b; ++i)
		pow3[i] = 3 * pow3[i-1];
}

void state2array(int s, int *a){
	for(int i = 0; i < max_b; ++i){
		a[i] = s % 3;
		s /= 3;
	}
}

int ex(int s, int *a, int p){
	if(a[p] < 2)
		return s + pow3[p];
	else
		return s - pow3[p];
}

ull dp[2][max_s];
int a[max_d];

ull count(ull n){
	int k = 0;
	while(n){
		a[k++] = n % 10;
		n /= 10;
	}

	int prev = 0, next = 1;
	memset(dp[prev], 0, sizeof(dp[prev]));
	for(int d = 1; d < a[k-1]; ++d)
		dp[prev][pow3[d]]++;

	int s = pow3[a[k-1]], sa[max_b];
	state2array(s, sa);

	for(int i = k-2; i >= 0; --i){
		memset(dp[next], 0, sizeof(dp[next]));
		
		for(int d = 1; d < max_b; ++d)
			dp[next][pow3[d]]++;
		
		for(int d = 0; d < a[i]; ++d)
			dp[next][ex(s, sa, d)]++;

		int ma[max_b];
		for(int m = 0; m < max_s; ++m){
			if(dp[prev][m]){
				state2array(m, ma);
				for(int d = 0; d < max_b; ++d)
					dp[next][ex(m, ma, d)] += dp[prev][m];
			}
		}

		s = ex(s, sa, a[i]);
		state2array(s, sa);

		swap(prev, next);
	}

	ull res = 0;

	int ma[max_b];
	for(int m = 0; m < max_s; ++m){
		state2array(m, ma);
		bool balanced = true;
		for(int d = 0; d < max_b; ++d){
			if(ma[d] && ma[d] % 2 == d % 2){
				balanced = false;
				break;
			}
		}
		if(balanced) res += dp[prev][m];
	}

	return res;
}

bool is_balanced(ull n){
	int a[max_b];
	memset(a, 0, sizeof(a));
	while(n){
		a[n % 10]++;
		n /= 10;
	}

	for(int d = 0; d < max_b; ++d)
		if(a[d] && a[d] % 2 == d % 2)
			return false;

	return true;
}

ull count_slow(ull n){
	ull res = 0;

	for(ull i = 1; i < n; ++i)
		if(is_balanced(i))
			res++;

	return res;
}

int main(){
	init_pow3();
	ull a, b;
	cin >> a >> b;
	cout << count(b+1) - count(a) << endl;

	return 0;
}
