
#include <cstdio>
#include <iostream>
#include <algorithm>
using namespace std;

const int MAX_SEQ_LEN = 100000 + 5;
const int MAX_CMD_LEN = 1000000 + 5;

int len;
int perm[MAX_SEQ_LEN];
int src_perm[MAX_SEQ_LEN];
int dst_perm[MAX_SEQ_LEN];

int rev_cnt;
pair<int, int> rev_arg[MAX_CMD_LEN];

void read() {
    scanf("%d", &len);
    for (int i = 0; i < len; ++i) scanf("%d", &src_perm[i]);
    for (int i = 0; i < len; ++i) scanf("%d", &dst_perm[i]);
}

void sort(int perm[]) {
    rev_cnt = 0;
	for (int i = 0; i < len; ++i) {
		for (int j = i + 1; j < len; ++j)
			if (perm[j] == i + 1) {
				reverse(perm + i, perm + j + 1);
				rev_arg[rev_cnt++] = make_pair(i, j);
				break;
			}
	}
}

void solve() {
    static int where[MAX_SEQ_LEN];
    for (int i = 0; i < len; ++i) where[dst_perm[i]] = i + 1;
    for (int i = 0; i < len; ++i) perm[i] = where[src_perm[i]];

    sort(perm);
    printf("%d\n", rev_cnt);
    for (int i = 0; i < rev_cnt; ++i)
        printf("%d %d\n", rev_arg[i].first + 1, rev_arg[i].second + 1);
}

int main() {
    read();
    solve();
    return 0;
}
