
#include <cstdio>
#include <cassert>
#include <iostream>
#include <algorithm>
using namespace std;

const int MAX_SEQ_LEN = 100000 + 5;
const int MAX_CMD_LEN = 2000000 + 5;

int len;
int perm[MAX_SEQ_LEN];
int src_perm[MAX_SEQ_LEN];
int dst_perm[MAX_SEQ_LEN];

int rev_cnt;
pair<int, int> rev_arg[MAX_CMD_LEN];

void read() {
    scanf("%d", &len);
    for (int i = 0; i < len; ++i) scanf("%d", &src_perm[i]);
    for (int i = 0; i < len; ++i) scanf("%d", &dst_perm[i]);
}

void merge(int perm[], int l, int m, int r) {
	pair<int, int> left_seq(l, m);
	pair<int, int> right_seq(m + 1, r);
	while (left_seq.first <= left_seq.second && right_seq.first <= right_seq.second) {
		if (perm[left_seq.first] < perm[right_seq.first]) {
			++left_seq.first;
		} else {
			int last = r - (right_seq.second - right_seq.first);
			int first = r - (right_seq.second - right_seq.first + 1) - (left_seq.second - left_seq.first);
			rev_arg[rev_cnt++] = make_pair(first, last);
			if (last - (first + 1) + 1 > 1)
				rev_arg[rev_cnt++] = make_pair(first + 1, last);
			++right_seq.first;
		}
	}
	
	static int temporary_values[MAX_SEQ_LEN];
	std::merge(perm + l, perm + m + 1, perm + m + 1, perm + r + 1, temporary_values);
	for (int i = l; i <= r; ++i)
		perm[i] = temporary_values[i - l];
}

void merge_sort(int perm[], int l, int r) {
	int len = r - l + 1;
	if (len > 1) {
		int m = (l + r) / 2;
		merge_sort(perm, l, m);
		merge_sort(perm, m + 1, r);
		merge(perm, l, m, r);
	}
}

void sort(int perm[]) {
    rev_cnt = 0;
	merge_sort(perm, 0, len - 1);
}

void solve() {
    static int where[MAX_SEQ_LEN];
    for (int i = 0; i < len; ++i) where[dst_perm[i]] = i + 1;
    for (int i = 0; i < len; ++i) perm[i] = where[src_perm[i]];

    sort(perm);
    printf("%d\n", rev_cnt);
    for (int i = 0; i < rev_cnt; ++i)
		printf("%d %d\n", rev_arg[i].first + 1, rev_arg[i].second + 1);
}

int main() {
    read();
    solve();
    return 0;
}
