
#include <cstdio>
#include <vector>
#include <cstdlib>
#include <ctime>
#include <algorithm>
using namespace std;

inline int randInt(int minValue, int maxValue) {
	return minValue + rand() % (maxValue - minValue + 1);
}

void randomiseSequence(vector<int> &seq, int cnt = 3) {
	while (cnt > 0) {
		for (int i = 1; i < seq.size(); ++i) {
			swap(seq[i], seq[randInt(0, i)]);
		}
		--cnt;
	}
}

void buildTestCase(int testcaseId, int length, int seed) {
	srand(seed);
	vector<int> srcPerm(length);
	for (int i = 0; i < length; ++i)
		srcPerm[i] = i + 1;
	vector<int> dstPerm = srcPerm;
	randomiseSequence(srcPerm);
	randomiseSequence(dstPerm);
	
	char filename[80];
	sprintf(filename, "reverse.%02d.in", testcaseId);
	puts(filename);
	FILE *fout = fopen(filename, "w");
	fprintf(fout, "%d\n", length);
	for (int i = 0; i < length; ++i) fprintf(fout, "%d%c", srcPerm[i], i < length - 1 ? ' ' : '\n');
	for (int i = 0; i < length; ++i) fprintf(fout, "%d%c", dstPerm[i], i < length - 1 ? ' ' : '\n');
	fclose(fout);
}

int main() {
	buildTestCase(1, 10, 362);
	buildTestCase(2, 50, 13667);
	buildTestCase(3, 100, 47327);
	buildTestCase(4, 100, 568899);
	
	buildTestCase(5, 5000, 3647);
	buildTestCase(6, 5000, 23526);
	buildTestCase(7, 5000, 283587);
	buildTestCase(8, 5000, 666);
	
	buildTestCase(9, 65000, 23862);
	buildTestCase(10, 65000, 9136823);
	buildTestCase(11, 65000, 1829376);
	buildTestCase(12, 65000, 28690016);
	
	buildTestCase(13, 100000, 23986526);
	buildTestCase(14, 100000, 6236627);
	buildTestCase(15, 100000, 8126863);
	buildTestCase(16, 100000, 1278667);
	return 0;
}